.nolist
.include "m8adef.inc"
.list

.def tmp = r16
.def buf = r17
.def b00 = r18
.def bff = r19
.def buf0 = r20
.def buf1 = r21
.def buf2 = r22
.def buf3 = r23
.def buf4 = r24
.def buf5 = r25
.def buf6 = r26
.def buf7 = r27

;1-wire port
;connect up to 8 DS18B20, each one to its own portpin!
.equ ddr = DDRB
.equ port = PORTB
.equ pin = PINB

.cseg
.org 000000

main:
;init stack pointer
.ifdef SPH ; if SPH is defined
ldi tmp,High(RAMEND)
out SPH,tmp ; Init MSB stack pointer
.endif
ldi tmp,Low(RAMEND)
out SPL,tmp ; Init LSB stack pointer

;init general purpose constant registers
clr	b00
ldi	bff, 0xff

;init 1-wire bus
out	ddr,	b00	;input
out	port,	bff	;pullup

;init uart to 4800 at 1MHz clock (internal RC oscillator)
ldi     tmp, HIGH(12)
out     UBRRH, tmp
ldi     tmp, LOW(12)
out     UBRRL, tmp
ldi     tmp, (1<<URSEL)|(3<<UCSZ0)
out     UCSRC, tmp
sbi     UCSRB, TXEN

; **********************************
loop:
rcall      sendreset
rcall      sendskiprom
rcall      sendconvert
;~750ms time to prepare data and send to uart
rcall      pivotbuffer
rcall      sendbuffer
;wait until all conversions finished
; -----------------------------
; warte 666000 Zyklen:
          ldi  R20, $1E
WGLOOP0:  ldi  R21, $31
WGLOOP1:  ldi  R22, $96
WGLOOP2:  dec  R22
          brne WGLOOP2
          dec  R21
          brne WGLOOP1
          rcall readbit    ;poll busy flags.
          cp buf, bff      ;if all of them are 1=done,
          breq convdone    ;exit the wait loop.
          dec  R20
          brne WGLOOP0
; -----------------------------
convdone:
rcall      sendreset
rcall      sendskiprom
rcall      readpad
rjmp loop

; **********************************
pivotbuffer:
;pivot r0..r7 into buf0..buf7
asr r0
ror buf0
asr r1
ror buf0
asr r2
ror buf0
asr r3
ror buf0
asr r4
ror buf0
asr r5
ror buf0
asr r6
ror buf0
asr r7
ror buf0

asr r0
ror buf1
asr r1
ror buf1
asr r2
ror buf1
asr r3
ror buf1
asr r4
ror buf1
asr r5
ror buf1
asr r6
ror buf1
asr r7
ror buf1

asr r0
ror buf2
asr r1
ror buf2
asr r2
ror buf2
asr r3
ror buf2
asr r4
ror buf2
asr r5
ror buf2
asr r6
ror buf2
asr r7
ror buf2

asr r0
ror buf3
asr r1
ror buf3
asr r2
ror buf3
asr r3
ror buf3
asr r4
ror buf3
asr r5
ror buf3
asr r6
ror buf3
asr r7
ror buf3

asr r0
ror buf4
asr r1
ror buf4
asr r2
ror buf4
asr r3
ror buf4
asr r4
ror buf4
asr r5
ror buf4
asr r6
ror buf4
asr r7
ror buf4

asr r0
ror buf5
asr r1
ror buf5
asr r2
ror buf5
asr r3
ror buf5
asr r4
ror buf5
asr r5
ror buf5
asr r6
ror buf5
asr r7
ror buf5

asr r0
ror buf6
asr r1
ror buf6
asr r2
ror buf6
asr r3
ror buf6
asr r4
ror buf6
asr r5
ror buf6
asr r6
ror buf6
asr r7
ror buf6

asr r0
ror buf7
asr r1
ror buf7
asr r2
ror buf7
asr r3
ror buf7
asr r4
ror buf7
asr r5
ror buf7
asr r6
ror buf7
asr r7
ror buf7
;move back into previous registers
mov r0, buf0
mov r1, buf1
mov r2, buf2
mov r3, buf3
mov r4, buf4
mov r5, buf5
mov r6, buf6
mov r7, buf7
;pivot r8..r15 into buf0..buf7
asr r8
ror buf0
asr r9
ror buf0
asr r10
ror buf0
asr r11
ror buf0
asr r12
ror buf0
asr r13
ror buf0
asr r14
ror buf0
asr r15
ror buf0

asr r8
ror buf1
asr r9
ror buf1
asr r10
ror buf1
asr r11
ror buf1
asr r12
ror buf1
asr r13
ror buf1
asr r14
ror buf1
asr r15
ror buf1

asr r8
ror buf2
asr r9
ror buf2
asr r10
ror buf2
asr r11
ror buf2
asr r12
ror buf2
asr r13
ror buf2
asr r14
ror buf2
asr r15
ror buf2

asr r8
ror buf3
asr r9
ror buf3
asr r10
ror buf3
asr r11
ror buf3
asr r12
ror buf3
asr r13
ror buf3
asr r14
ror buf3
asr r15
ror buf3

asr r8
ror buf4
asr r9
ror buf4
asr r10
ror buf4
asr r11
ror buf4
asr r12
ror buf4
asr r13
ror buf4
asr r14
ror buf4
asr r15
ror buf4

asr r8
ror buf5
asr r9
ror buf5
asr r10
ror buf5
asr r11
ror buf5
asr r12
ror buf5
asr r13
ror buf5
asr r14
ror buf5
asr r15
ror buf5

asr r8
ror buf6
asr r9
ror buf6
asr r10
ror buf6
asr r11
ror buf6
asr r12
ror buf6
asr r13
ror buf6
asr r14
ror buf6
asr r15
ror buf6

asr r8
ror buf7
asr r9
ror buf7
asr r10
ror buf7
asr r11
ror buf7
asr r12
ror buf7
asr r13
ror buf7
asr r14
ror buf7
asr r15
ror buf7
;move back into previous registers
mov r8, buf0
mov r9, buf1
mov r10, buf2
mov r11, buf3
mov r12, buf4
mov r13, buf5
mov r14, buf6
mov r15, buf7
ret

sendbuffer:
;convert r0..r15 to hex and send to uart
;r0 + r8 = 1st sensor
;r1 + r9 = 2nd sensor
mov buf, r8
rcall tohex
mov buf, YH
rcall sendusart
mov buf, YL
rcall sendusart
mov buf, r0
rcall tohex
mov buf, YH
rcall sendusart
mov buf, YL
rcall sendusart
ldi buf, ","
rcall sendusart

mov buf, r9
rcall tohex
mov buf, YH
rcall sendusart
mov buf, YL
rcall sendusart
mov buf, r1
rcall tohex
mov buf, YH
rcall sendusart
mov buf, YL
rcall sendusart
ldi buf, ","
rcall sendusart

mov buf, r10
rcall tohex
mov buf, YH
rcall sendusart
mov buf, YL
rcall sendusart
mov buf, r2
rcall tohex
mov buf, YH
rcall sendusart
mov buf, YL
rcall sendusart
ldi buf, ","
rcall sendusart

mov buf, r11
rcall tohex
mov buf, YH
rcall sendusart
mov buf, YL
rcall sendusart
mov buf, r3
rcall tohex
mov buf, YH
rcall sendusart
mov buf, YL
rcall sendusart
ldi buf, ","
rcall sendusart

mov buf, r12
rcall tohex
mov buf, YH
rcall sendusart
mov buf, YL
rcall sendusart
mov buf, r4
rcall tohex
mov buf, YH
rcall sendusart
mov buf, YL
rcall sendusart
ldi buf, ","
rcall sendusart

mov buf, r13
rcall tohex
mov buf, YH
rcall sendusart
mov buf, YL
rcall sendusart
mov buf, r5
rcall tohex
mov buf, YH
rcall sendusart
mov buf, YL
rcall sendusart
ldi buf, ","
rcall sendusart

mov buf, r14
rcall tohex
mov buf, YH
rcall sendusart
mov buf, YL
rcall sendusart
mov buf, r6
rcall tohex
mov buf, YH
rcall sendusart
mov buf, YL
rcall sendusart
ldi buf, ","
rcall sendusart

mov buf, r15
rcall tohex
mov buf, YH
rcall sendusart
mov buf, YL
rcall sendusart
mov buf, r7
rcall tohex
mov buf, YH
rcall sendusart
mov buf, YL
rcall sendusart
;line break:
ldi buf, 13
rcall sendusart
ldi buf, 10
rcall sendusart
ret

sendusart:
sbis    UCSRA,UDRE
rjmp    sendusart
out     UDR, buf
ret

tohex:
;input = buf (0..255)
;output = YL + YH
mov	tmp, buf
andi	tmp, 0x0F
rcall	tmptohex
mov	YL, tmp
mov	tmp, buf
swap	tmp
andi	tmp, 0x0F
rcall	tmptohex
mov	YH, tmp
ret

tmptohex:
cpi	tmp, 10
brsh	hexletter
hexnum:
ldi	ZL, 0x30
add	tmp, ZL			; add 48 (0x30) for ascii chars "0" thru "9"
ret
hexletter:
ldi	ZL, 0x37
add	tmp, ZL			; add 55 (0x37) for ascii chars "A" thru "F"
ret

; All data is read and written least significant bit first
; = ALSO RUECKWAERTS!!
sendreadrom:
;send byte 0x33 = 0b00110011
rcall     sendone
rcall     sendone
rcall     sendzero
rcall     sendzero
rcall     sendone
rcall     sendone
rcall     sendzero
rcall     sendzero
ret

sendskiprom:
;send byte 0xCC = 0b11001100
rcall     sendzero
rcall     sendzero
rcall     sendone
rcall     sendone
rcall     sendzero
rcall     sendzero
rcall     sendone
rcall     sendone
ret

sendconvert:
;send byte 0x44 = 0b01000100
rcall     sendzero
rcall     sendzero
rcall     sendone
rcall     sendzero
rcall     sendzero
rcall     sendzero
rcall     sendone
rcall     sendzero
;enable strong pullup for parasite power
;out	ddr,	bff	;output
;out	port,	bff	;high
ret

readpad:
;read the first two bytes of the pad
;send byte 0xBE = 0b10111110
rcall     sendzero
rcall     sendone
rcall     sendone
rcall     sendone
rcall     sendone
rcall     sendone
rcall     sendzero
rcall     sendone
;use r0..r15 instead of sram
rcall     readbit
mov       r0, buf
rcall     readbit
mov       r1, buf
rcall     readbit
mov       r2, buf
rcall     readbit
mov       r3, buf
rcall     readbit
mov       r4, buf
rcall     readbit
mov       r5, buf
rcall     readbit
mov       r6, buf
rcall     readbit
mov       r7, buf
rcall     readbit
mov       r8, buf
rcall     readbit
mov       r9, buf
rcall     readbit
mov       r10, buf
rcall     readbit
mov       r11, buf
rcall     readbit
mov       r12, buf
rcall     readbit
mov       r13, buf
rcall     readbit
mov       r14, buf
rcall     readbit
mov       r15, buf
ret

sendone:
;6us bus low
;64us bus open
out	ddr,	bff	;output
out	port,	b00	;low
nop
nop
nop
nop
out	ddr,	b00	;input
out	port,	bff	;pullup
ldi	tmp,	20
sendoneloop:
dec	tmp
brne	sendoneloop
ret

sendzero:
;60us bus low
;10us bus open
out	ddr,	bff	;output
out	port,	b00	;low
ldi	tmp,	19
sendzeroloop:
dec	tmp
brne	sendzeroloop
nop
out	ddr,	b00	;input
out	port,	bff	;pullup
nop
nop
nop
nop
nop
nop
ret

sendreset:
;480us bus low
;480us bus open
out	ddr,	bff	;output
out	port,	b00	;low
ldi	tmp,	159
sendrst1loop:
dec	tmp
brne	sendrst1loop
nop
out	ddr,	b00	;input
out	port,	bff	;pullup
ldi	tmp,	158
sendrst2loop:
dec	tmp
brne	sendrst2loop
nop
nop
ret

readbit:
;6us bus low
;9us bus high
;read
;55us nop
out	ddr,	bff	;output
out	port,	b00	;low
nop
nop
nop
nop
out	ddr,	b00	;input
out	port,	bff	;pullup
nop
nop
nop
nop
nop
nop
nop
nop
nop
in	buf,   pin
ldi	tmp,	17
readbitloop:
dec	tmp
brne	readbitloop
;nop
ret
;
